Attribute VB_Name = "ModPublic"
Option Explicit
' // PUBLIC DECLARES & ROUTINES //
Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type POINTAPI
    X As Long
    Y As Long
End Type

' mouse pointer "Hand" with shadow (only really usefull if background is white)
Public Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Public Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
Public Const IDC_HAND = 32649&

'Misc.
Public Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByRef lpvParam As Any, ByVal fuWinIni As Long) As Long
Public Const SPI_GETWORKAREA = 48
Public Declare Function GetForegroundWindow Lib "user32" () As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Const SW_SHOW = 5

' Translucent
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000
Private Const LWA_ALPHA = &H2

Private Declare Function GetWindowLong Lib "user32" _
  Alias "GetWindowLongA" (ByVal hwnd As Long, _
  ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" _
   Alias "SetWindowLongA" (ByVal hwnd As Long, _
   ByVal nIndex As Long, ByVal dwNewLong As Long) _
   As Long

Private Declare Function SetLayeredWindowAttributes Lib _
    "user32" (ByVal hwnd As Long, ByVal crKey As Long, _
    ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
    
' save & restore form pos and size
Private Type WINDOWPLACEMENT
    length As Long
    FLAGS As Long
    showCmd As Long
    ptMinPosition As POINTAPI
    ptMaxPosition As POINTAPI
    rcNormalPosition As RECT
End Type

Private Type WINDOWPOS
    hwnd As Long
    hWndInsertAfter As Long
    X As Long
    Y As Long
    cx As Long
    cy As Long
    FLAGS As Long
End Type

Private Declare Function GetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long

Public Sub SavePosition(ByVal AppName As String, ByVal Section As String, ByVal frm As Form)
    ' // Save users form pos & size settings //
    Dim wp As WINDOWPLACEMENT
    wp.length = LenB(wp)
    GetWindowPlacement frm.hwnd, wp
    SaveSetting AppName, Section, frm.Name & "_Pos", _
     wp.rcNormalPosition.Left & "," & _
     wp.rcNormalPosition.Top & "," & _
     wp.rcNormalPosition.Right - wp.rcNormalPosition.Left & "," & _
     wp.rcNormalPosition.Bottom - wp.rcNormalPosition.Top
End Sub

Public Function RestorePosition(ByVal AppName As String, ByVal Section As String, ByVal frm As Form) As Boolean
    ' Restore form pos & size to users last used //
    Dim DeskTop As RECT
    Dim sTmp As String
    Dim Size_Pos() As String
    sTmp = GetSetting(AppName, Section, frm.Name & "_Pos", "")
    If Len(sTmp) > 0 Then
        Size_Pos() = Split(sTmp, ",")
        MoveWindow frm.hwnd, Val(Size_Pos(0)), Val(Size_Pos(1)), Val(Size_Pos(2)), Val(Size_Pos(3)), 1
        RestorePosition = True
    End If
    ' make sure form is inside desktop area incase desktop resolution/size has changed
    CheckEdge frm.hwnd
End Function

Private Sub CheckEdge(FrmHwnd As Long)
    ' // Keep a form in the desktop area.//
    Dim l As Long, t As Long, w As Long, h As Long
    Dim DeskTop As RECT, MyForm As RECT
    
    SystemParametersInfo SPI_GETWORKAREA, 0&, DeskTop, 0&  'Desktop area
    GetWindowRect FrmHwnd, MyForm                          'get form area

    l = MyForm.Left
    t = MyForm.Top
    w = MyForm.Right - MyForm.Left ' the form width
    h = MyForm.Bottom - MyForm.Top ' the form height
    ' make sure form is not larger then desktop area.
    If h > (DeskTop.Bottom - DeskTop.Top) Then h = (DeskTop.Bottom - DeskTop.Top)
    If w > (DeskTop.Right - DeskTop.Left) Then w = (DeskTop.Right - DeskTop.Left)
    ' Check if form edges are off screen.
    If MyForm.Top < DeskTop.Top Then t = DeskTop.Top
    If MyForm.Left < DeskTop.Left Then l = DeskTop.Left
    If t > DeskTop.Bottom - h Then t = DeskTop.Bottom - h
    If l > DeskTop.Right - w Then l = DeskTop.Right - w
    ' reposition the window
    MoveWindow FrmHwnd, l, t, w, h, 1
End Sub

Public Sub TranslucentForm(f As Form, TranslucenceLevel As Integer)
    ' // Make form translucent(semi-transparent) //
    '0 = completely transparent, 255 = completely opaque
    'Requires: Windows2000, XP, or later.
    SetWindowLong f.hwnd, GWL_EXSTYLE, GetWindowLong(f.hwnd, GWL_EXSTYLE) Or WS_EX_LAYERED
    SetLayeredWindowAttributes f.hwnd, 0, TranslucenceLevel, LWA_ALPHA
End Sub

Public Sub OpenURL(sURL As String)
    ' // Open Url with defualt web browser //
    If sURL = "" Then Exit Sub ' Ignore if empty
    ' URLs should end in a number for forums!
    If IsNumeric(Right$(sURL, 1)) = True Then
        ShellExecute GetDesktopWindow(), "open", sURL, 0&, 0&, SW_SHOW
    Else
        MsgBox "Sorry, the URL to this topic is not available!", vbApplicationModal + vbInformation
    End If
End Sub

