Attribute VB_Name = "ModToolTip"
'///////////////////////////////////////////////
'//           Balloon ToolTip Lite v2.2       //
'//      Edgemeal, updated May 17, 2010       //
'///////////////////////////////////////////////
' This is a light "Modular" version of ToolTip class.

Option Explicit
'Windows API Functions
'Private Declare Sub InitCommonControls Lib "comctl32.dll" ()
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

'Windows API Types
'Private Type RECT
'        Left As Long
'        Top As Long
'        Right As Long
'        Bottom As Long
'End Type
'Windows API Constants
Private Const WS_EX_TOPMOST As Long = &H8& ' Edgemeal (Ed Wilk) added: keeps balloon on top of "always on top" forms!
Private Const WM_USER As Long = &H400
Private Const CW_USEDEFAULT As Long = &H80000000
'Tooltip Window Constants
Private Const TTS_NOPREFIX As Long = &H2
Private Const TTM_ADDTOOLA As Long = (WM_USER + 4)
Private Const TTM_UPDATETIPTEXTA As Long = (WM_USER + 12)
Private Const TTM_SETTITLE As Long = (WM_USER + 32)
Private Const TTS_BALLOON As Long = &H40
Private Const TTS_ALWAYSTIP As Long = &H1
Private Const TTF_SUBCLASS As Long = &H10
Private Const TTF_IDISHWND As Long = &H1
Private Const TTM_SETDELAYTIME As Long = (WM_USER + 3)
Private Const TTDT_AUTOPOP As Long = 2
Private Const TTDT_INITIAL As Long = 3
Private Const TOOLTIPS_CLASSA As String = "tooltips_class32"
'Tooltip Window Types
Private Type TOOLINFO
    lSize As Long
    lFlags As Long
    hwnd As Long
    lId As Long
    lpRect As RECT
    hInstance As Long
    lpStr As String
    lParam As Long
End Type
'private data
'Private IsInitialized As Boolean
Private m_lTTHwnd As Long ' hwnd of the tooltip
Private Last_hWnd As Long
Private ti As TOOLINFO
Private m_bInLable As Boolean

Public Sub ToolTipOff()
    ' // kill/reset tooltip //
    If m_lTTHwnd <> 0 Then
        DestroyWindow m_lTTHwnd
        m_lTTHwnd = 0
    End If
   m_bInLable = False
End Sub

Public Sub ShowToolTip(ByVal Title As String, ByVal ToolTipText As String, ByVal Control_hWnd As Long)
    ' // Show ToolTip Ballon //
    Dim lWinStyle As Long
    
'    ' if InitCommonControls has already been loaded then this can be removed. (i.e. in a form for XP Styles)
'    If IsInitialized = False Then
'        IsInitialized = True
'        InitCommonControls
'    End If
    
'    ' (bug fix) This is only needed if you have overlapping controls.
'    If Last_hWnd <> Control_hWnd Then
'        Last_hWnd = Control_hWnd
'        ToolTipOff
'    End If


    ' show balloon....
    If m_bInLable = False Then
        m_bInLable = True
        If m_lTTHwnd <> 0 Then DestroyWindow m_lTTHwnd
        ' tooltip text
        ti.lpStr = ToolTipText
        If m_lTTHwnd <> 0 Then SendMessage m_lTTHwnd, TTM_UPDATETIPTEXTA, 0&, ti
        lWinStyle = TTS_ALWAYSTIP Or TTS_NOPREFIX
        lWinStyle = lWinStyle Or TTS_BALLOON 'create baloon style , remove "Or TTS_BALLOON" for regular box style.
        m_lTTHwnd = CreateWindowEx(WS_EX_TOPMOST, TOOLTIPS_CLASSA, vbNullString, lWinStyle, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0&, 0&, App.hInstance, 0&)
        'now set our tooltip info structure
        With ti
            .lFlags = TTF_SUBCLASS Or TTF_IDISHWND
            .hwnd = Control_hWnd 'set the hwnd prop to our parent control's hwnd
            .lId = Control_hWnd
            .hInstance = App.hInstance
            .lSize = Len(ti)
        End With
        'add the tooltip structure
        SendMessage m_lTTHwnd, TTM_ADDTOOLA, 0&, ti
        'if we want a title or we want an icon
        If Title <> vbNullString Then
            SendMessage m_lTTHwnd, TTM_SETTITLE, 1, ByVal Title
        End If
        SendMessage m_lTTHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, ByVal 9000&   ' on time
        SendMessage m_lTTHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, ByVal 800& ' delay time to show
    End If
End Sub

