Attribute VB_Name = "ModWinHook"
Option Explicit
' // subclass for mouse whell //
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const GWL_WNDPROC = (-4)
Private Const WM_MOUSEWHEEL = &H20A
Private PrevWin As Long

Public Sub Hook(ByVal handle As Long)
    If PrevWin = 0 Then
        PrevWin = SetWindowLong(handle, GWL_WNDPROC, AddressOf FrmMain_Proc)
    End If
End Sub

Public Sub Unhook(handle As Long)
    If PrevWin Then
        Call SetWindowLong(handle, GWL_WNDPROC, PrevWin)
        PrevWin = 0
    End If
End Sub

Private Function FrmMain_Proc(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    '// ' this hook is used to detect and pass messages to our form //
    
    ' WM_MOUSEWHEEL  - MSDN notes...
    ' The WM_MOUSEWHEEL message is sent to the focus window when the mouse wheel is rotated.
    'wParam: The high-order word indicates the distance the wheel is rotated, expressed in multiples or
    'divisions of WHEEL_DELTA, which is 120. A positive value indicates that the wheel was rotated
    'forward, away from the user; a negative value indicates that the wheel was rotated backward,
    'toward the user.
    ' lparam: not needed , many options, look up WM_MOUSEWHEEL on MSDN.
    
    If Msg = WM_MOUSEWHEEL Then  ' the mouse wheel rotated
        FrmMain.MouseWheel wParam / 65536  ' Rotation = wParam / 65536
    End If
    FrmMain_Proc = CallWindowProc(PrevWin, hwnd, Msg, wParam, lParam)
End Function

